# Description

## A mod that allows you to change some things when you die. Keep, Destroy, or Drop your items based on the YAML and normal config.

`Version checks with itself. If installed on the server, it will kick clients who do not have it installed.`

`This mod uses ServerSync, if installed on the server and all clients, it will sync all configs to client`

`This mod uses a file watcher. If the configuration file is not changed with BepInEx Configuration manager, but changed in the file directly on the server, upon file save, it will sync the changes to all clients.`


---

The configuration files generated by this mod are `Azumatt.HelheimHarmonizer.cfg` and `Azumatt.HelheimHarmonizer.yml` and are located in the `BepInEx/config` folder. The files will be created after you run the game with the mod installed at least once.

<details>   
<summary><b>Installation Instructions</b></summary>

***You must have BepInEx installed correctly! I can not stress this enough.***

### Manual Installation

`Note: (Manual installation is likely how you have to do this on a server, make sure BepInEx is installed on the server correctly)`

1. **Download the latest release of BepInEx.**
2. **Extract the contents of the zip file to your game's root folder.**
3. **Download the latest release of  from Thunderstore.io.**
4. **Extract the contents of the zip file to the `BepInEx/plugins` folder.**
5. **Launch the game.**

### Installation through r2modman or Thunderstore Mod Manager

1. **Install [r2modman](https://valheim.thunderstore.io/package/ebkr/r2modman/)
   or [Thunderstore Mod Manager](https://www.overwolf.com/app/Thunderstore-Thunderstore_Mod_Manager).**

   > For r2modman, you can also install it through the Thunderstore site.
   ![](https://i.imgur.com/s4X4rEs.png "r2modman Download")

   > For Thunderstore Mod Manager, you can also install it through the Overwolf app store
   ![](https://i.imgur.com/HQLZFp4.png "Thunderstore Mod Manager Download")
2. **Open the Mod Manager and search for "HelheimHarmonizer" under the Online
   tab. `Note: You can also search for "Azumatt" to find all my mods.`**

   `The image below shows VikingShip as an example, but it was easier to reuse the image.`

   ![](https://i.imgur.com/5CR5XKu.png)

3. **Click the Download button to install the mod.**
4. **Launch the game.**

</details>

<br>

<details><summary><b>Configuration Options</b></summary> 

`1 - General`

Lock Configuration [Synced with Server]
* If on, the configuration is locked and can be changed by server admins only.
   * Default Value: On

`1 - Pin Control`

TotalPinRemoval [Synced with Server]
* If on, no death pin will be created when the player dies.
   * Default Value: Off

RemovePinOnTombstoneInteract [Synced with Server]
* If on, the death pin for the tombstone will be removed when the tombstone is fully looted.
   * Default Value: On

`2 - Death Control`

NoItemLossOnDeath [Synced with Server]
* If on, you will not lose any items on death.
   * Default Value: Off

CreateDeathEffects [Synced with Server]
* Toggle death effects when the player dies.
   * Default Value: On

ClearFoods [Synced with Server]
* Toggle clearing the player's food list when the player dies.
   * Default Value: On

ReduceSkills [Synced with Server]
* Toggle skill reduction when the player dies.
   * Default Value: On

SkillReduceFactor [Synced with Server]
* The factor to reduce the player's skills by when ReduceSkills is on. 0.25 is vanilla.
   * Default Value: 0.25

`3 - Spawn Control`

SpawnAtStart [Synced with Server]
* Toggle spawning at the start location when the player dies.
   * Default Value: Off

UseFixedSpawnCoordinates [Synced with Server]
* If on, the player will spawn at the fixed spawn coordinates.
   * Default Value: Off

FixedSpawnCoordinates [Synced with Server]
* The fixed spawn coordinates to use when UseFixedSpawnCoordinates is on.
   * Default Value: {"x":0.0,"y":0.0,"z":0.0}





</details>

<br>

<details><summary><b>YAML Configuration Example/Options</b></summary>

```yml
# Below you can find example groups. Groups are used to exclude or includeOverride quickly. They are reusable lists! 
# Please note that some of these groups/container limitations are kinda pointless but are here for example.
# Make sure to follow the format of the example below. If you have any questions, please ask in my discord.

# Full vanilla prefab name list: https://valheim-modding.github.io/Jotunn/data/prefabs/prefab-list.html
# Item prefab name list: https://valheim-modding.github.io/Jotunn/data/objects/item-list.html

# There are several predefined groups set up for you that are not listed. You can use these just like you would any group you create yourself.
# These are the "All", "Food", "Potion", "Fish", "Swords", "Bows", "Crossbows", "Axes", "Clubs", "Knives", "Pickaxes", "Polearms", "Spears", "Equipment", "Boss Trophy", "Trophy", "Crops", "Seeds", "Ores", "Metals", and "Woods" groups.
# The criteria for these groups are as follows:
# groups:
#   Food:
#     - Criteria: Both of the following properties must have a value greater than 0.0 on the sharedData property of the ItemDrop script:
#         - food
#         - foodStamina
#   Potion:
#     - Criteria: The following properties must meet the specified conditions on the sharedData property of the ItemDrop script:
#         - food > 0.0
#         - foodStamina == 0.0
#   Fish:
#     - itemType: Fish
#   Swords, Bows, Crossbows, Axes, Clubs, Knives, Pickaxes, Polearms, Spears:
#     - itemType: OneHandedWeapon, TwoHandedWeapon, TwoHandedWeaponLeft, Bow
#     - Criteria: Items in these groups have a specific skillType on the sharedData property of the ItemDrop script. Each group corresponds to the skillType as follows:
#         - Swords: skillType == Skills.SkillType.Swords
#         - Bows: skillType == Skills.SkillType.Bows
#         - Crossbows: skillType == Skills.SkillType.Crossbows
#         - Axes: skillType == Skills.SkillType.Axes
#         - Clubs: skillType == Skills.SkillType.Clubs
#         - Knives: skillType == Skills.SkillType.Knives
#         - Pickaxes: skillType == Skills.SkillType.Pickaxes
#         - Polearms: skillType == Skills.SkillType.Polearms
#         - Spears: skillType == Skills.SkillType.Spears
#            Example:   An item with itemType set to OneHandedWeapon and skillType set to Skills.SkillType.Swords would belong to the Swords group.
#   Armor:
#     - itemType: Chest, Legs, Hands, Helmet, Shoulder
#   Equipment:
#     - itemType: Torch
#   Boss Trophy:
#     - itemType: Trophie
#     - Criteria: sharedData.m_name ends with any of the following boss names:
#         - eikthyr, elder, bonemass, dragonqueen, goblinking, SeekerQueen
#   Trophy:
#     - itemType: Trophie
#     - Criteria: sharedData.m_name does not end with any boss names
#   Crops:
#     - itemType: Material
#     - Criteria: Can be cultivated and grown into a pickable object with an amount greater than 1
#   Seeds:
#     - itemType: Material
#     - Criteria: Can be cultivated and grown into a pickable object with an amount equal to 1
#   Ores:
#     - itemType: Material
#     - Criteria: Can be processed by any of the following smelters:
#         - smelter
#         - blastfurnace
#   Metals:
#     - itemType: Material
#     - Criteria: Is the result of processing an ore in any of the following smelters:
#         - smelter
#         - blastfurnace
#   Woods:
#     - itemType: Material
#     - Criteria: Can be processed by the charcoal_kiln smelter
#   All:
#     - Criteria: Item has an ItemDrop script and all needed fields are populated. (all items)


groups:
  Arrows:
    - ArrowBronze
    - ArrowCarapace
    - ArrowFire
    - ArrowFlint
    - ArrowFrost
    - ArrowIron
    - ArrowNeedle
    - ArrowObsidian
    - ArrowPoison
    - ArrowSilver
    - ArrowWood
    - draugr_arrow
  Scraps:
    - BlackMetalScrap
    - BronzeScrap
    - CopperScrap
    - IronScrap
    - LeatherScraps
  Tier2Items:
    - Bronze
    - PickaxeBronze
    - ArmorBronzeChest
    - ArmorBrozeLeggings

# Please note that the inventory and hotbar sections are exclusive.
# If the item is excluded from the inventory but the item is in the hotbar, it will be dropped in the hotbar. This is the same for the other way around.
# To explain more simply, if you want to keep an item no matter what, you must include it in both sections. Otherwise, it will be dropped/destroyed in the section that it is not excluded from.

# Configure inventory rules here.
inventory:
  exclude: # List groups or individual items to exclude from dropping in the main inventory.
    - Swords # Exclude all items in the "Swords" group.
    - Tier2Items # Exclude all items in the "Tier2Items" group.
    - Bows # Exclude all items in the "Bows" group.
  includeOverride: # List groups or individual items to always drop in the main inventory, even if they are listed in the exclude section of the inventory.
    - BowFineWood # Always drop the item "BowFineWood" in the main inventory.
    - Wood # Always drop the item "Wood" in the main inventory.
  #destroy: # List groups or individual items to destroy instead of dropping in the main inventory.
    #- Arrows # Destroy the item "Arrows" instead of dropping it in the main inventory.
    #- Scraps # Destroy the item "Scraps" instead of dropping it in the main inventory.

# Configure hotbar rules here.
hotbar:
  exclude: # List groups or individual items to exclude from dropping in the hotbar.
    - Food # Exclude all items in the "Food" group.
    - PickaxeBronze # Exclude the item "PickaxeBronze" from the hotbar.
  includeOverride: # List groups or individual items to always drop in the hotbar, even if they are listed in the exclude section.
    - PickaxeBronze # Always drop the item "PickaxeBronze" in the hotbar.
  #destroy: # List groups or individual items to destroy instead of dropping in the hotbar.
    #- Arrows # Destroy the item "Arrows" instead of dropping it in the hotbar.
    #- Scraps # Destroy the item "Scraps" instead of dropping it in the hotbar.


```

</details>


<br>
<br>

`Feel free to reach out to me on discord if you need manual download assistance.`

# Author Information

### Azumatt

`DISCORD:` Azumatt#2625

`STEAM:` https://steamcommunity.com/id/azumatt/

For Questions or Comments, find me in the Odin Plus Team Discord or in mine:

[![https://i.imgur.com/XXP6HCU.png](https://i.imgur.com/XXP6HCU.png)](https://discord.gg/Pb6bVMnFb2)
<a href="https://discord.gg/pdHgy6Bsng"><img src="https://i.imgur.com/Xlcbmm9.png" href="https://discord.gg/pdHgy6Bsng" width="175" height="175"></a>